"use strict";
var channel_1 = require('../../channel');
var common_1 = require('../common');
var rule;
(function (rule) {
    function markType() {
        return 'rule';
    }
    rule.markType = markType;
    function properties(model) {
        var p = {};
        if (model.has(channel_1.X)) {
            p.x = position(model, channel_1.X);
            p.y = { value: 0 };
            p.y2 = {
                field: { group: 'height' }
            };
        }
        if (model.has(channel_1.Y)) {
            p.y = position(model, channel_1.Y);
            p.x = { value: 0 };
            p.x2 = {
                field: { group: 'width' }
            };
        }
        common_1.applyColorAndOpacity(p, model);
        if (model.has(channel_1.SIZE)) {
            p.strokeWidth = {
                scale: model.scaleName(channel_1.SIZE),
                field: model.field(channel_1.SIZE)
            };
        }
        else {
            p.strokeWidth = { value: sizeValue(model) };
        }
        return p;
    }
    rule.properties = properties;
    function position(model, channel) {
        return {
            scale: model.scaleName(channel),
            field: model.field(channel, { binSuffix: '_mid' })
        };
    }
    function sizeValue(model) {
        var fieldDef = model.fieldDef(channel_1.SIZE);
        if (fieldDef && fieldDef.value !== undefined) {
            return fieldDef.value;
        }
        return model.config().mark.ruleSize;
    }
    function labels(model) {
        return undefined;
    }
    rule.labels = labels;
})(rule = exports.rule || (exports.rule = {}));
//# sourceMappingURL=rule.js.map